(** Computations **)
genrule(
  xframe(result(var(x)),var(m),var(pc),var(s),var(l)),
  frame(var(m),next(var(pc)),stack(var(x),var(s)),var(l))
);
(* xadd *)
genrule(xadd(zero,zero),result(zero));
genrule(xadd(succ(var(a)),pred(var(b))),xadd(var(a),var(b)));
genrule(xadd(pred(var(a)),succ(var(b))),xadd(var(a),var(b)));
genrule(xadd(succ(var(a)),succ(var(b))),xadd(succ(succ(var(a))),var(b)));
genrule(xadd(pred(var(a)),pred(var(b))),xadd(pred(pred(var(a))),var(b)));
genrule(xadd(succ(var(a)),zero),result(succ(var(a))));
genrule(xadd(pred(var(a)),zero),result(pred(var(a))));
genrule(xadd(zero,succ(var(b))),result(succ(var(b))));
genrule(xadd(zero,pred(var(b))),result(pred(var(b))));
(* xsub *)
genrule(xsub(var(a),zero),result(var(a)));
genrule(xsub(zero,pred(var(a))),xsub(succ(zero),var(a)));
genrule(xsub(zero,succ(var(a))),xsub(pred(zero),var(a)));
genrule(xsub(pred(var(a)),pred(var(b))),xsub(var(a),var(b)));
genrule(xsub(pred(var(a)),succ(var(b))),xsub(pred(pred(var(a))),var(b)));
genrule(xsub(succ(var(a)),pred(var(b))),xsub(succ(succ(var(a))),var(b)));
genrule(xsub(succ(var(a)),succ(var(b))),xsub(var(a),var(b)));
(* ifNeint *)
genrule(ifNeint(var(x),zero,zero),ifXx(val_false,var(x)));
genrule(ifNeint(var(x),succ(var(a)),pred(var(b))),ifXx(val_true,var(x)));
genrule(ifNeint(var(x),pred(var(a)),succ(var(b))),ifXx(val_true,var(x)));
genrule(ifNeint(var(x),succ(var(a)),succ(var(b))),ifNeint(var(x),var(a),var(b)));
genrule(ifNeint(var(x),pred(var(a)),pred(var(b))),ifNeint(var(x),var(a),var(b)));
genrule(ifNeint(var(x),succ(var(a)),zero),ifXx(val_true,var(x)));
genrule(ifNeint(var(x),pred(var(a)),zero),ifXx(val_true,var(x)));
genrule(ifNeint(var(x),zero,succ(var(b))),ifXx(val_true,var(x)));
genrule(ifNeint(var(x),zero,pred(var(b))),ifXx(val_true,var(x)));
(* ifEqint *)
genrule(ifEqint(var(x),zero,zero),ifXx(val_true,var(x)));
genrule(ifEqint(var(x),succ(var(a)),pred(var(b))),ifXx(val_false,var(x)));
genrule(ifEqint(var(x),pred(var(a)),succ(var(b))),ifXx(val_false,var(x)));
genrule(ifEqint(var(x),succ(var(a)),succ(var(b))),ifEqint(var(x),var(a),var(b)));
genrule(ifEqint(var(x),pred(var(a)),pred(var(b))),ifEqint(var(x),var(a),var(b)));
genrule(ifEqint(var(x),succ(var(a)),zero),ifXx(val_false,var(x)));
genrule(ifEqint(var(x),pred(var(a)),zero),ifXx(val_false,var(x)));
genrule(ifEqint(var(x),zero,succ(var(b))),ifXx(val_false,var(x)));
genrule(ifEqint(var(x),zero,pred(var(b))),ifXx(val_false,var(x)));
(* ifGeint *)
genrule(ifGeint(var(x),zero,zero),ifXx(val_true,var(x)));
genrule(ifGeint(var(x),succ(var(a)),pred(var(b))),ifXx(val_true,var(x)));
genrule(ifGeint(var(x),pred(var(a)),succ(var(b))),ifXx(val_false,var(x)));
genrule(ifGeint(var(x),succ(var(a)),succ(var(b))),ifGeint(var(x),var(a),var(b)));
genrule(ifGeint(var(x),pred(var(a)),pred(var(b))),ifGeint(var(x),var(a),var(b)));
genrule(ifGeint(var(x),succ(var(a)),zero),ifXx(val_true,var(x)));
genrule(ifGeint(var(x),pred(var(a)),zero),ifXx(val_false,var(x)));
genrule(ifGeint(var(x),zero,succ(var(b))),ifXx(val_false,var(x)));
genrule(ifGeint(var(x),zero,pred(var(b))),ifXx(val_true,var(x)));
(* ifLeint *)
genrule(ifLeint(var(x),zero,zero),ifXx(val_true,var(x)));
genrule(ifLeint(var(x),succ(var(a)),pred(var(b))),ifXx(val_false,var(x)));
genrule(ifLeint(var(x),pred(var(a)),succ(var(b))),ifXx(val_true,var(x)));
genrule(ifLeint(var(x),succ(var(a)),succ(var(b))),ifLeint(var(x),var(a),var(b)));
genrule(ifLeint(var(x),pred(var(a)),pred(var(b))),ifLeint(var(x),var(a),var(b)));
genrule(ifLeint(var(x),succ(var(a)),zero),ifXx(val_false,var(x)));
genrule(ifLeint(var(x),pred(var(a)),zero),ifXx(val_true,var(x)));
genrule(ifLeint(var(x),zero,succ(var(b))),ifXx(val_true,var(x)));
genrule(ifLeint(var(x),zero,pred(var(b))),ifXx(val_false,var(x)));
(* ifGtint *)
genrule(ifGtint(var(x),zero,zero),ifXx(val_false,var(x)));
genrule(ifGtint(var(x),succ(var(a)),pred(var(b))),ifXx(val_true,var(x)));
genrule(ifGtint(var(x),pred(var(a)),succ(var(b))),ifXx(val_false,var(x)));
genrule(ifGtint(var(x),succ(var(a)),succ(var(b))),ifGtint(var(x),var(a),var(b)));
genrule(ifGtint(var(x),pred(var(a)),pred(var(b))),ifGtint(var(x),var(a),var(b)));
genrule(ifGtint(var(x),succ(var(a)),zero),ifXx(val_true,var(x)));
genrule(ifGtint(var(x),pred(var(a)),zero),ifXx(val_false,var(x)));
genrule(ifGtint(var(x),zero,succ(var(b))),ifXx(val_false,var(x)));
genrule(ifGtint(var(x),zero,pred(var(b))),ifXx(val_true,var(x)));
(* ifLtint *)
genrule(ifLtint(var(x),zero,zero),ifXx(val_false,var(x)));
genrule(ifLtint(var(x),succ(var(a)),pred(var(b))),ifXx(val_false,var(x)));
genrule(ifLtint(var(x),pred(var(a)),succ(var(b))),ifXx(val_true,var(x)));
genrule(ifLtint(var(x),succ(var(a)),succ(var(b))),ifLtint(var(x),var(a),var(b)));
genrule(ifLtint(var(x),pred(var(a)),pred(var(b))),ifLtint(var(x),var(a),var(b)));
genrule(ifLtint(var(x),succ(var(a)),zero),ifXx(val_false,var(x)));
genrule(ifLtint(var(x),pred(var(a)),zero),ifXx(val_true,var(x)));
genrule(ifLtint(var(x),zero,succ(var(b))),ifXx(val_true,var(x)));
genrule(ifLtint(var(x),zero,pred(var(b))),ifXx(val_false,var(x)));
(* ifXx *)
genrule(xframe(ifXx(val_true,var(x)),var(m),var(pc),var(s),var(l)),
frame(var(m),var(x),var(s),var(l)));
genrule(xframe(ifXx(val_false,var(x)),var(m),var(pc),var(s),var(l)),
frame(var(m),next(var(pc)),var(s),var(l)));
(* negint *)
genrule(negint(succ(var(a)),var(b)),negint(var(a),pred(var(b))));
genrule(negint(pred(var(a)),var(b)),negint(var(a),succ(var(b))));
genrule(negint(zero,var(b)),result(var(b)));
