load definitions.rex;

genrule(nthstack(zero,var(ds),var(s)),resultstack(reversestack(var(ds),nilstackU),var(s)));
for i from 1 to $nb_classes
do(
  let stack = $get_stack($i) in (
    genrule(
      nthstack(succ(var(i)),var(s),op($stack,(var(o),var(lk),var(n)))),
      nthstack(var(i),op($stack,(var(o),var(lk),var(s))),var(n))
    );
    genrule(
      xMergeHeapStack(op($stack,(var(o),var(lk),nilstackU)),var(n)),
      xMergeHeapStack(nilstackU,op($stack,(var(o),var(lk),var(n))))
    );
    genrule(
      xMergeHeapStack(op($stack,(var(o1),var(lk1),op($stack,(var(o2),var(lk2),var(s))))),var(n)),
      op($stack,(var(o1),var(lk1),xMergeHeapStack(op($stack,(var(o2),var(lk2),var(s))),var(n))))
    );
    genrule(
      op($stack,(var(o),var(lk),resultstackmerge(var(n)))),
      resultstackmerge(op($stack,(var(o),var(lk),var(n))))
    );
    genrule(
      reversestack(op($stack,(var(o),var(lk),var(n))),var(s)),
      reversestack(var(n),op($stack,(var(o),var(lk),var(s))))
    );
  );
);
genrule(reversestack(nilstackU,var(s)),var(s));

genrule(nthheap(var(i),heap(var(n),var(s))),nthstack(var(i),nilstackU,var(s)));

genrule(xMergeHeapStack(nilstackU,var(s)),resultstackmerge(var(s)));

for i from 1 to $nb_classes
do(
  genrule(
    xGetHeap($get_class($i),heaps($heap_vars)),
    getn($heap_vars,$i)
  );
  genrule(
    xGetHeapStack(loc($get_class($i),var(i)),heaps($heap_vars)),
    preparenthheap(var(i),xGetHeap($get_class($i),heaps($heap_vars)))
  );

  let stack = $get_stack($i) in (
    genrule(
      xGetLock(var(tid),resultstack(var(ds),op($stack,(var(o),lock(var(oid),zero),var(n))))),
      xTakeLock(val_true,xHeapStackToMerge(var(ds),op($stack,(var(o),lock(var(tid),zero),var(n)))))
    );
    genrule(
      xGetLock(var(tid),resultstack(var(ds),op($stack,(var(o),lock(var(oid),succ(var(c))),var(n))))),
      xTakeLock(ifEqint(wait,var(tid),var(oid)),
      xHeapStackToMerge(var(ds),op($stack,(var(o),lock(var(oid),succ(var(c))),var(n)))))
    );

    (* for lock releasing, we assume that tid = oid *)
    genrule(
      xReleaseLock(var(tid),resultstack(var(ds),op($stack,(var(o),lock(var(oid),var(c)),var(n))))),
      xLockReleased(xHeapStackToMerge(var(ds),op($stack,(var(o),lock(var(oid),var(c)),var(n)))))
    );

    genrule(
      state(threadlist(thread(var(tl),xframe(xMonitorEnter(xTakeLock(val_true,
      xHeapStackToMerge(var(ds),op($stack,(var(o),lock(var(oid),var(c)),var(n)))))),var(m),var(pc),
      var(s),var(l)),var(f)),var(ntl)),$gen_heaps($i,var(a),var(hs)),var(k),var(tc)),
      state(threadlist(thread(var(tl),xframe(xMonitorEnter(xMerging),var(m),var(pc),var(s),var(l)),
      var(f)),var(ntl)),$gen_heaps($i,var(a),xMergeHeapStack(var(ds),
      op($stack,(var(o),lock(var(oid),succ(var(c))),var(n))))),var(k),var(tc))
    );

    (* for lock releasing, we assume that lock has been taken at least once *)
    genrule(
      state(threadlist(thread(var(tl),xframe(xMonitorExit(xLockReleased(
      xHeapStackToMerge(var(ds),op($stack,(var(o),lock(var(oid),succ(var(c))),var(n)))))),var(m),var(pc),
      var(s),var(l)),var(f)),var(ntl)),$gen_heaps($i,var(a),var(hs)),var(k),var(tc)),
      state(threadlist(thread(var(tl),xframe(xMonitorExit(xMerging),var(m),var(pc),var(s),var(l)),
      var(f)),var(ntl)),$gen_heaps($i,var(a),xMergeHeapStack(var(ds),
      op($stack,(var(o),lock(var(oid),var(c)),var(n))))),var(k),var(tc))
    );
  );
  genrule(
    state(threadlist(thread(var(tl),xframe(xMonitorEnter(xMerging),var(m),var(pc),stack(var(x),var(s)),
    var(l)),var(f)),var(ntl)),$gen_heaps($i,var(a),resultstackmerge(var(hs))),var(k),var(tc)),
    state(threadlist(thread(var(tl),frame(var(m),next(var(pc)),var(s),var(l)),
    var(f)),var(ntl)),$gen_heaps($i,var(a),var(hs)),var(k),var(tc))
  );

  genrule(
    state(threadlist(thread(var(tl),xframe(xMonitorExit(xMerging),var(m),var(pc),stack(var(x),var(s)),
    var(l)),var(f)),var(ntl)),$gen_heaps($i,var(a),resultstackmerge(var(hs))),var(k),var(tc)),
    state(threadlist(thread(var(tl),frame(var(m),next(var(pc)),var(s),var(l)),
    var(f)),var(ntl)),$gen_heaps($i,var(a),var(hs)),var(k),var(tc))
  );
);

genrule(xTakeLock(ifXx(var(b),var(x)),var(s)),xTakeLock(var(b),var(s)));

genrule(
  preparenthheap(succ(var(i)),heap(succ(var(sz)),var(s))),
  preparenthheap(xsub(var(sz),succ(var(i))),heap(var(sz),var(s)))
);
genrule(
  preparenthheap(zero,heap(succ(var(sz)),var(s))),
  preparenthheap(result(var(sz)),heap(var(sz),var(s)))
);
genrule(
  preparenthheap(result(var(i)),var(h)),
  nthheap(var(i),var(h))
);

(* monitorenter *)
genrule(
  state(threadlist(thread(threadloc(var(r),var(tid)),xframe(monitorenter,var(m),var(pc),
  stack(var(x),var(s)),var(l)),var(f)),var(ntl)),var(h),var(k),var(tc)),
  state(threadlist(thread(threadloc(var(r),var(tid)),
  xframe(xMonitorEnter(xGetLock(var(tid),xGetHeapStack(var(x),var(h)))),var(m),var(pc),
  stack(var(x),var(s)),var(l)),var(f)),var(ntl)),var(h),var(k),var(tc))
);

genrule(
  state(threadlist(thread(threadloc(var(r),var(tid)),xframe(xMonitorEnter(xTakeLock(val_false,var(w))),
  var(m),var(pc),stack(var(x),var(s)),var(l)),var(f)),var(ntl)),var(h),var(k),var(tc)),
  state(threadlist(thread(threadloc(var(r),var(tid)),
  xframe(xMonitorEnter(xGetLock(var(tid),xGetHeapStack(var(x),var(h)))),var(m),var(pc),
  stack(var(x),var(s)),var(l)),var(f)),var(ntl)),var(h),var(k),var(tc))
);

(* monitorexit *)
genrule(
  state(threadlist(thread(threadloc(var(r),var(tid)),xframe(monitorexit,var(m),var(pc),
  stack(var(x),var(s)),var(l)),var(f)),var(ntl)),var(h),var(k),var(tc)),
  state(threadlist(thread(threadloc(var(r),var(tid)),
  xframe(xMonitorExit(xReleaseLock(var(tid),xGetHeapStack(var(x),var(h)))),var(m),var(pc),
  stack(var(x),var(s)),var(l)),var(f)),var(ntl)),var(h),var(k),var(tc))
);